<template>
  <div class="relative">
    <div class="absolute w-full h-full transition-transform duration-500 transform-style-3d" :class="{ 'rotate-y-180': flipped }" @click="flipCard">
      <slot name="front">
        <div class="absolute w-full h-full bg-blue-200 rounded-xl shadow-md backface-hidden">Front Content</div>
      </slot>
      <slot name="back">
        <div class="absolute w-full h-full bg-green-200 rounded-xl shadow-md backface-hidden rotate-y-180">Back Content</div>
      </slot>
    </div>
  </div>
</template>

<script setup lang="ts">
const props = defineProps<{
  id: Number | String;
  flipped: Boolean;
  canClick: boolean;
}>();

const emit = defineEmits(['onFlipCard']);

const flipCard = () => {
  if (!props.canClick) {
    return;
  }
  emit('onFlipCard', props.id);
};
</script>

<style scoped>
.transform-style-3d {
  transform-style: preserve-3d;
}
.backface-hidden {
  -webkit-backface-visibility: hidden;
  backface-visibility: hidden;
}
</style>
